#include <bits/stdc++.h>
using namespace std;
using ll=long long;
using ld=double;
using vll=vector<ll>;
#define FOR(i,a,b) for(ll i=a;i<(ll)b;++i)
#define ROF(i,a,b) for(ll i=a;i>=(ll)b;--i)
#define PB push_back

void print_v(vector<double> v)
{
  for (double d : v)
    printf("%d ", (int) d);
  printf("\n");
}

template<typename It>
long long moves(const vector<double>& X, const It& fixed, const int K)
{
  auto pos = fixed + 1;
  long long total_moves = 0;
  for (int i = 1; pos != X.end(); ++pos, ++i)
  {
    printf("%d ", (int)(*pos));
    int required_pos = (int)(*fixed + K * i);
    int diff = (int)(abs(required_pos - *pos));
    total_moves += diff;
  }

  printf("\n");
  if (fixed == X.begin())
    return total_moves;
  pos = fixed - 1;
  for (int i = 1; ; --pos, ++i)
  {
    printf("%d ", (int)(*pos));
    int required_pos = (int)(*fixed - K * i);
    int diff = (int)(abs(required_pos - *pos));
    total_moves += diff;
  
    if (pos == X.begin())
      break;
  }
  return total_moves;
}

int main(){
  ios::sync_with_stdio(0);cin.tie(0);

  int N, K;
  scanf("%d %d", &N, &K);
  long long sum = 0;
  vector<double> X(N);
  for (int i = 0; i < N; ++i)
  {
    int x;
    scanf("%d", &x);
    X[i] = x;

    sum += x;
  }
  sort(X.begin(), X.end());
  print_v(X);
  const double mean = sum / (double) N;
  auto fixed = lower_bound(X.begin(), X.end(), mean);
  if (fixed != X.begin() && (mean - *(fixed - 1) < *fixed - mean))
    --fixed;

  printf("%lf\n", *fixed);
  long long m = moves(X, fixed - 2, K);
  printf("\n%lld\n", m);
  return 0;
}
