#include <bits/stdc++.h>
using namespace std;
using ll=long long;
using ld=double;
using vll=vector<ll>;
#define FOR(i,a,b) for(ll i=a;i<(ll)b;++i)
#define ROF(i,a,b) for(ll i=a;i>=(ll)b;--i)
#define PB push_back

#define MOD 1'000'000'007

int main(){
  ios::sync_with_stdio(0);cin.tie(0);

  int64_t N, K, M;
  cin >> N >> K >> M;

  int64_t** v1;
  int64_t** v2;
  int64_t** v3;

  auto seta = [](int64_t**& v){
    v = new int64_t*[19];
    for(size_t i = 0 ;i < 19; i++){
      v[i] = new int64_t[19];
    }
  };
  seta(v1);
  seta(v2);
  seta(v3);

  vector<bool> rigid(N, false);
  vector<int64_t> v(N, -1);

  for(size_t i = 0;i < M; i++){
    int64_t C, R, V;
    cin >> C >> R >> V;
    if(v[C] == -1)v[C] = V;
    else{
      rigid[C] = true;
      v[C] += V;
    }
  }


  int64_t probs[19] = {
    1, 2, 3, 4, 5, 6, 7, 8, 9, 10,
    9, 8, 7, 6, 5, 4, 3, 2, 1,
  };

  auto swp = [&](){swap(v1, v2); swap(v2, v3);};
  auto clr = [](int64_t** v){
    for(size_t i = 0;i < 19; i++){
      for(size_t j = 0;j < 19; j++){
        v[i][j] = 0;
      }
    }
  };

  clr(v1);

  for(size_t i = 0; i < 19;i++){
    int64_t p;
    int64_t s;
    if(rigid[i]){
      p = 1;
      s = v[0];
    }else if(v[i] != -1){
      if(i > 9)break;
      p = 1;
      s = v[0] + i;
    }else{
      s = i;
      p = probs[i];
    }

    for(size_t j = 0; j < 19; j++){
      int64_t p2;
      int64_t s2;
      if(rigid[j]){
        p2 = 1;
        s2 = v[1];
      }else if(v[j] != -1){
        if(j > 9)break;
        p2 = 1;
        s2 = v[1] + j;
      }else{
        s2 = j;
        p2 = probs[j];
      }
      //cout << s << " " << p << " " << s2 << " " << p2 << endl;
      v1[s][s2] = p*p2;
      if(rigid[i])break;
    }

    if(rigid[i])break;
  }

  for(size_t h = 2; h < N; h++){
    for(size_t i = 0; i < 19;i++){
      for(size_t j = 0; j < 19; j++){
        int64_t s = i+j;
        int64_t n = K-s;
        int64_t p = 0;

        if(rigid[h]){
          if(n == v[h])p=1;
          else p=0;
        }else if(v[h] != -1){
          if(n >= 0 && n <= 9)p = 1;
        }else{
          if(n >= 0 && n <= 18)p = probs[n];
        }

        v2[j][n] = (p * v1[i][j]) % MOD;
      }
    }
    swp();
  }

  int64_t s = 0;
  for(size_t i = 0; i < 19;i++){
    for(size_t j = 0; j < 19; j++){
      s = (s+v1[i][j])%MOD;
    }
  }
  cout << s << endl;
  return 0;
}
